clear all;close all;
P=double(imread('fingerprint.bmp'));
K=[3.99 3.96 0.6 4 3.999 3.997];tic
C=paraencry(P,K);toc
D=paradecry(C,K);
 set(gcf,'position',[400,400,800,270])
 subplot(131),imshow(uint8(P)),axis off, axis image, colormap(gray),title('Plaintext Image')
 subplot(132),imshow(uint8(C)),axis off, axis image, colormap(gray),title('Ciphertext Image')
 subplot(133),imshow(uint8(D)),axis off, axis image, colormap(gray),title('Decrypted Image')
 

% Histogram 
figure,
set(gcf,'position',[400,400,800,270])
subplot(131),imhist(uint8(P)),axis square, colormap(gray),title('Plaintext Image')
subplot(132),imhist(uint8(C)),axis square, colormap(gray),title('Ciphertext Image')
subplot(133),imhist(uint8(D)),axis square, colormap(gray),title('Decrypted Image')

%% Entropy
InforE = entropy(uint8(C))

%% Adajacent Pixel Correlation (to be done)

% NPCR UACI/ Plaintext sensitivity
NPCR = @(X,Y) sum(X(:)~=Y(:))/numel(X)*100;
UACI = @(X,Y) sum(sum(imabsdiff(X,Y)))/numel(X)/255*100;
% Plaintext Sensitivity
P2 = P;
P2(128,128) = 0; %<----change one pixel
C2 = paraencry(P2,K);;

npcrP = NPCR(C,C2);
uaciP = UACI(C,C2);

figure,
set(gcf,'position',[400,400,800,500])
subplot(231),imagesc(P),axis square, colormap(gray),title('$P_1$','Interpreter','Latex')
subplot(232),imagesc(P2),axis square, colormap(gray),title('$P_2$','Interpreter','Latex')
subplot(233),imagesc(imabsdiff(P,P2)),axis square, colormap(gray),title('$|P_1-P_2|$','Interpreter','Latex')
subplot(234),imagesc(C),axis square, colormap(gray),title('$C_1$','Interpreter','Latex')
subplot(235),imagesc(C2),axis square, colormap(gray),title('$C_2$','Interpreter','Latex')
subplot(236),imagesc(imabsdiff(C,C2)),axis square, colormap(gray),title('$|C_1-C_2|$','Interpreter','Latex')
imwrite(uint8(C),'fruiten.png');
imwrite(uint8(P2),'fruitone.png');
imwrite(uint8(imabsdiff(P,P2)),'fruitdiff.png');
imwrite(uint8(C2),'fruitoneen.png');
imwrite(uint8(imabsdiff(C,C2)),'fruitdiffen.png');




%% Key Sensitivity
D3=paraencry(P,K);
 npcrK = NPCR(D3,C);
 uaciK = UACI(D3,C);

% put commond 'axis off' in figures, in case you donot like it. 
figure,
set(gcf,'position',[400,400,950,270])
subplot(141),imagesc(P),axis square, colormap(gray),title('$P$','Interpreter','Latex')
subplot(142),imagesc(C),axis square, colormap(gray),title('$C_1$: encrypting $P$ using $K_1$','Interpreter','Latex')
subplot(143),imagesc(D3),axis square, colormap(gray),title('$C_2$: encrypting $P$ using $K_2$','Interpreter','Latex')
subplot(144),imagesc(imabsdiff(C,D3)),axis square, colormap(gray),title('$|C_1-C_2|$','Interpreter','Latex')
DK1=paradecry(D3,K);
K1=K;K1(3)=0.2;
DK2=paradecry(D3,K1);
imwrite(uint8(DK2),'flowergrayde1.png');

figure
set(gcf,'position',[400,400,800,500])
subplot(131),imagesc(C),axis square, colormap(gray),title('$C_1$: Encrypting $P$ using $K_1$','Interpreter','Latex')
subplot(132),imagesc(DK1),axis square, colormap(gray),title('Decrypting $C_1$ using $K_1$','Interpreter','Latex')
subplot(133),imagesc(DK2),axis square, colormap(gray),title('Decrypting $C_1$ using $K_2$','Interpreter','Latex')
% subplot(234),imagesc(C3),axis square, colormap(gray),title('$C_2$: Encrypting $P$ using $K_2$','Interpreter','Latex')
% subplot(235),imagesc(DK1),axis square, colormap(gray),title('Decrypting $C_2$ using $K_1$','Interpreter','Latex')
% subplot(236),imagesc(D),axis square, colormap(gray),title('Decrypting $C_2$ using $K_2$','Interpreter','Latex')
